<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Http\Requests\Addrequest;
use Validator;
use App\Models\Prize;
use App\Models\SpinDetail;
use App\Models\Customer;


class PrizeController extends Controller
{
    public function addPrice(Request $request)
    {
        $validator = Validator::make($request->all(), [
        'name'=> 'required',
        'color'=> 'required',
        'music_effect'=> 'required',
        'win_chance'=> 'required',
        'count'=> 'required',
        'effect'=> 'required',

        ]);

        if ($validator->fails()) {
            return back()
           ->withErrors($validator)
           ->withInput();
        }

        $AddPrice= new Prize();
        $AddPrice->name=$request->name;
        $AddPrice->color=$request->color;
        $AddPrice->music_effect=$request->music_effect;
        $AddPrice->win_chance=$request->win_chance;
        $AddPrice->count=$request->count;
        $AddPrice->effect=$request->effect;
        $AddPrice->is_active=1;

       if($AddPrice->save())
       {
        return redirect('get-prize')->with('success','Prize added successfully');
       }
       else
       {
        return back()->with('error','Prize added successfully');

       }
    }
    public function GetPrize()
    {
         $prizes=Prize::get();

         return view('view-prize',compact('prizes'));
    }
    public function getCustomer()
    {
         $customers=Customer::all();
         $deal_customer=Customer::where('get_deal',1)->get();
         $not_deal_customer=Customer::where('get_deal',0)->get();


         return view('customerlist',compact('customers','deal_customer','not_deal_customer'));

    }
     public function getSpin()
    {

         $spin_time=SpinDetail::find(1);
         return view('spinDetial',compact('spin_time'));

    }
     public function updateSpinTime(Request $request)
    {
         $validator = Validator::make($request->all(), [
        'spin_time' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            return back()
           ->withErrors($validator)
           ->withInput();
        }
        $updatespin=SpinDetail::find(1);
        $updatespin->spin_time=$request->spin_time;
        $updatespin->spin_valid_time=$request->spin_valid_time ?? $updatespin->spin_valid_time;
        if($updatespin->save())
        {
             return back()->with('success','Saved Successfully');
        }
        else
        {
            return back()->with('error','Error Occured');

        }


    }
     public function UpdatePage($id)
    {

         $prize=Prize::find($id);

         return view('updatePrize',compact('prize'));

    }
     public function updatePrize(Request $request,$id)
     {
        $find_prize=Prize::find($id);

        $validator = Validator::make($request->all(), [
        'name'=> 'required',
        'color'=> 'required',
        'music_effect'=> 'required',
        'win_chance'=> 'required',
        'count'=> 'required',
        'effect'=> 'required',

        ]);

        if ($validator->fails()) {
            return back()
           ->withErrors($validator)
           ->withInput();
        }

        $find_prize->name=$request->name;
        $find_prize->color=$request->color;
        $find_prize->music_effect=$request->music_effect;
        $find_prize->win_chance=$request->win_chance;
        $find_prize->count=$request->count;
        $find_prize->effect=$request->effect;
        $find_prize->is_active=$request->is_active ?? 0;

       if($find_prize->save())
       {

        return redirect('get-prize')->with('success','Updated successfully');
       }
       else
       {

        return back()->with('error','No Data Updated');

       }

     }
     public function DeletePrize($id)
     {

         $prize=Prize::find($id);

         $prize->delete();

         return back()->with('success','Deleted Successfully');

     }
}
