<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Prize;
use App\Http\Requests\Addrequest;
use App\Models\Customer;
use Carbon\Carbon;
use App\Models\SpinDetail;



class CustomerController extends Controller
{
    public function GetSpin()
    {
         $get_prizes=Prize::get();
         $spin_time=SpinDetail::find(1);
         if($get_prizes)
         {
                   return response()
                   ->json(['status'=>'success','message'=>'Data Found Successfully','spin_time'=>$spin_time->spin_time,'data'=>$get_prizes],200);
         }
         else
         {
            return response()
                   ->json(['status'=>'error','message'=>'No Data Found'],401);
         }
    }

      public function AddSpin(Addrequest $request)
      {
         $check=Customer::where('phone_number',$request->phone_number)->where('is_valid',0)->get();
         if(sizeof($check)>0)
         {
         foreach($check as $phone)
         {
           $check=$phone->created_at;
           $future_time=$check->addMinutes(59);
           $current_time=Carbon::now();
            if($current_time>=$future_time)
           {
             Customer::where('id',$phone->id)->update(['is_valid'=>1]);
           }

         }

             return response()->json(['status'=>'error','message'=>'You Can Not Spin Before 60 min'],500);
         }
         else
         {
            // Get the current date and time
           $currentDateTime = Carbon::now();

            // Format the current date and time as a string
           $formattedDate = $currentDateTime->format('Y-m-d');
           $formattedTime = $currentDateTime->format('h:i A');


         $addspin= new Customer();
         $addspin->name=$request->name;
         $addspin->phone_number=$request->phone_number;
         $addspin->prize_id=$request->prize_id;
         $addspin->get_deal=$request->get_deal;
         $addspin->time=$formattedTime;
         $addspin->date=$formattedDate;

         $data=$addspin->save();

          if($data)
          {

          return response()->json(['status'=>'success','message'=>'data added successfully'],200);

          }
          else
          {

           return response()->json(['status'=>'error','message'=>'error occured'],500);


          }

         }



    }
    public function SearchCustomer(Request $request)
    {
      if(isset($request['phone_number'])&& !empty([$request['phone_number']]))
      {
         $check=Customer::where('phone_number',$request->phone_number)->where('is_valid',0)->where('is_collected',0)->get();

         if(sizeof($check)>0)
         {

         foreach($check as $phone)
         {
           $check=$phone->created_at;
           $future_time=$check->addMinutes(59);
           $current_time=Carbon::now();
          if($current_time>=$future_time)
           {
             Customer::where('id',$phone->id)->update(['is_valid'=>1]);

             return response()->json(['status'=>'error','message'=>'Coupon Is Invalid'],401);

           }
           else
           {

               $find_phone=Customer::where([['phone_number',$request->phone_number],['is_valid','0'],['is_collected','0']])->get();

               return response()->json(['status'=>'success','message'=>'data found successfully','data'=>$find_phone],200);



           }

         }
         }
         else
         {
                         return response()->json(['status'=>'error','message'=>'No Data Found'],401);

         }
      }
      else
      {
                return response()->json(['status'=>'error','message'=>'Incomplete Param'],401);

      }
    }

    public function CollectPrize(Request $request)
    {
       if(isset($request['id'])&& !empty([$request['id']]))
       {
          $find_id=Customer::where('id',$request->id);
          if($find_id->exists())
          {
            $Collect_prize=$find_id->update([
            'is_collected'=>1
            ]);
             if($Collect_prize)
             {
                return response()->json(['status'=>'success','message'=>'Prize Collected Successfully','data'=>$find_id->get()],200);

             }
          }
          else
          {
              return response()->json(['status'=>'error','message'=>'No Data Found'],401);

          }


       }
       else
       {
                return response()->json(['status'=>'error','message'=>'Incomplete Param'],401);

       }

    }
}
